/* kody klawiszy */
#define MOD_CONTROL_LEFT    (1<<0)
#define MOD_SHIFT_LEFT      (1<<1)
#define MOD_ALT_LEFT        (1<<2)
#define MOD_GUI_LEFT        (1<<3)
#define MOD_CONTROL_RIGHT   (1<<4)
#define MOD_SHIFT_RIGHT     (1<<5)
#define MOD_ALT_RIGHT       (1<<6)
#define MOD_GUI_RIGHT       (1<<7)

#define KEY_A       4
#define KEY_B       5
#define KEY_C       6
#define KEY_D       7
#define KEY_E       8
#define KEY_F       9
#define KEY_G       10
#define KEY_H       11
#define KEY_I       12
#define KEY_J       13
#define KEY_K       14
#define KEY_L       15
#define KEY_M       16
#define KEY_N       17
#define KEY_O       18
#define KEY_P       19
#define KEY_Q       20
#define KEY_R       21
#define KEY_S       22
#define KEY_T       23
#define KEY_U       24
#define KEY_V       25
#define KEY_W       26
#define KEY_X       27
#define KEY_Y       28
#define KEY_Z       29
#define KEY_1       30
#define KEY_2       31
#define KEY_3       32
#define KEY_4       33
#define KEY_5       34
#define KEY_6       35
#define KEY_7       36
#define KEY_8       37
#define KEY_9       38
#define KEY_0       39

#define KEY_F1      58
#define KEY_F2      59
#define KEY_F3      60
#define KEY_F4      61
#define KEY_F5      62
#define KEY_F6      63
#define KEY_F7      64
#define KEY_F8      65
#define KEY_F9      66
#define KEY_F10     67
#define KEY_F11     68
#define KEY_F12     69
#define UP_ARROW  	   0x52
#define DOWN_ARROW     0x51
#define LEFT_ARROW     0x50
#define RIGHT_ARROW    0x4F
#define SPACE		   0x2C
#define PAGE_UP		   0x4B
#define PAGE_DOWN	   0x4E
#define BACKSPACE	   0x2A
#define ENTER		   0x28


/* klawisze consumer */
#define Scan_Next_Track		0x01
#define Scan_Previous_Track	0x02
#define Stop				0x04
#define Play_Pause			0x08
#define Mute				0x10
#define Volume_Up			0x20
#define Volume_Down			0x40

/* system control */
#define Power				0x01
#define Sleep				0x02
#define Wake				0x04
				

/*mouse*/

#define LMB 		0x01
#define RMB 		0x02
#define MMB 		0x04

#define Mouse_left 		248
#define Mouse_right 	8

#define Mouse_up 		248
#define Mouse_down	 	8

#define Mouse_wheel_down	255
#define Mouse_wheel_up	1


/* report id */
#define Mouse			1
#define Consumer		2
#define Keyboard		3
#define System			4

/************************************************************************************************************************
 *																														*
 *											tablica z klawiszami															*
 *																														*
 ************************************************************************************************************************/
 char keys_table [] [5] = { 

/* command  0 - cyfra 0					*/	{0, 0, 0, 0, 0},
/* command  1 - cyfra 1					*/	{Consumer, Play_Pause, 0, 0, 0}, // play/paue
/* command  2 - cyfra 2					*/	{Consumer, Stop, 0, 0, 0}, // stop
/* command  3 - cyfra 3					*/	{0, 0, 0, 0, 0}, 
/* command  4 - cyfra 4					*/	{Consumer, Scan_Previous_Track, 0, 0, 0}, // prev track
/* command  5 - cyfra 5					*/	{Consumer, Scan_Next_Track, 0, 0, 0}, // next track
/* command  6 - cyfra 6					*/	{Keyboard, MOD_CONTROL_LEFT | MOD_ALT_LEFT, UP_ARROW, 0, 0}, // vol up winamp
/* command  7 - cyfra 7					*/	{Keyboard, MOD_CONTROL_LEFT | MOD_ALT_LEFT, LEFT_ARROW, 0, 0}, // rewind winamp
/* command  8 - cyfra 8					*/	{Keyboard, MOD_CONTROL_LEFT | MOD_ALT_LEFT, RIGHT_ARROW, 0, 0}, // forward winamp
/* command  9 - cyfra 9					*/	{Keyboard, MOD_CONTROL_LEFT | MOD_ALT_LEFT, DOWN_ARROW, 0, 0}, // vol down winamp
/* command 10 - -/--					*/	{0, 0, 0, 0, 0},
/* command 11 - P/C						*/	{0, 0, 0, 0, 0},
/* command 12 - standby					*/	{System, Power, 0, 0, 0}, // PC off
/* command 13 - mute					*/	{Consumer, Mute, 0, 0, 0}, // mute
/* command 14 - normalizacja			*/	{0, 0, 0, 0, 0},
/* command 15 - info					*/	{0, 0, 0, 0, 0},
/* command 16 - głośność +			*/	{Mouse, 0, Mouse_right, 0, 0}, //mysz w prawo
/* command 17 - głośność -			*/	{Mouse, 0, Mouse_left, 0, 0}, //mysz w lewo
/* command 18 - jaskrawość +			*/	{0, 0, 0, 0, 0},
/* command 19 - jaskrawość -			*/	{0, 0, 0, 0, 0},
/* command 20 - nasycenie +				*/	{0, 0, 0, 0, 0},
/* command 21 - nasycenie -				*/	{0, 0, 0, 0, 0},
/* command 22 - niskie +				*/	{0, 0, 0, 0, 0},
/* command 23 - niskie -				*/	{0, 0, 0, 0, 0},
/* command 24 - wysokie +				*/	{0, 0, 0, 0, 0},
/* command 25 - wysokie -				*/	{0, 0, 0, 0, 0},
/* command 26 - balans (w prawo)		*/	{0, 0, 0, 0, 0},
/* command 27 - balans (w lewo)			*/	{0, 0, 0, 0, 0},
/* command 28 - kontrast +				*/	{Consumer, Volume_Up, 0, 0, 0}, // vol up
/* command 29 - kontrast -				*/	{Consumer, Volume_Down, 0, 0, 0}, //vol down
/* command 30 - szukaj +				*/	{0, 0, 0, 0, 0},
/* command 31 - zmniejszenie odcienia	*/	{0, 0, 0, 0, 0},
/* command 32 - program +				*/	{Mouse, 0, 0, Mouse_up, 0}, //mysz w górę
/* command 33 - program -				*/	{Mouse, 0, 0, Mouse_down,  0}, //mysz w dół
/* command 34 - P<P						*/	{Keyboard, 0, BACKSPACE, 0, 0}, // SUBEDIT WYCISZENIE
/* command 35 - I/II					*/	{Keyboard, 0, KEY_G, 0, 0}, // SUBEDIT ZEGAR
/* command 36 - przestrzenne stereo		*/	{0, 0, 0, 0, 0},
/* command 37 - stereo/mono				*/	{0, 0, 0, 0, 0},
/* command 38 - sleep timer				*/	{System, Sleep, 0, 0, 0},
/* command 39 - zwiększenie odcienia	*/	{0, 0, 0, 0, 0},
/* command 40 - 						*/	{0, 0, 0, 0, 0},
/* command 41 - txt						*/	{Keyboard, 0, DOWN_ARROW, 0, 0}, //subedit -1m
/* command 42 - czas (txt)				*/	{0, 0, 0, 0, 0},
/* command 43 - txt						*/	{Keyboard, 0, PAGE_DOWN, 0, 0}, //subedit ciszej
/* command 44 - txt?					*/	{Keyboard, 0, LEFT_ARROW, 0, 0}, // -5s
/* command 45 - txt X					*/	{Keyboard, MOD_CONTROL_LEFT, KEY_M, 0, 0}, // subedit stop
/* command 46 - APP						*/	{0, 0, 0, 0, 0},
/* command 47 - zegar					*/	{0, 0, 0, 0, 0},
/* command 48 - 						*/	{0, 0, 0, 0, 0},
/* command 49 - 						*/	{0, 0, 0, 0, 0},
/* command 50 - txt yellow				*/	{Keyboard, 0, RIGHT_ARROW, 0, 0}, // subedit +5s
/* command 51 - 						*/	{0, 0, 0, 0, 0},
/* command 52 - txt blue				*/	{Keyboard, 0,PAGE_UP, 0, 0}, // subedit głośniej
/* command 53 - txt i					*/	{0, 0, 0, 0, 0},
/* command 54 - txt green				*/	{Keyboard, 0, UP_ARROW,  0, 0}, // subedit +1m
/* command 55 - txt red					*/	{Keyboard, 0, SPACE, 0, 0}, // subedit play/pause
/* command 56 - AV						*/	{0, 0, 0, 0, 0},
/* command 57 - 						*/	{0, 0, 0, 0, 0},
/* command 58 - 						*/	{0, 0, 0, 0, 0},
/* command 59 - OK						*/	{Mouse, LMB, 0, 0, 0}, //Mouse LMB
/* command 60 - 						*/	{0, 0, 0, 0, 0},
/* command 61 - 						*/	{0, 0, 0, 0, 0},
/* command 62 - 						*/	{0, 0, 0, 0, 0},
/* command 63 - TV						*/	{System, Wake, 0, 0, 0},
};


